



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>maven 中的pom中的 dependencyManagement 和 dependencies</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">maven 中的pom中的 dependencyManagement 和 dependencies</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 07:53:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>参考：<a href="https://blog.csdn.net/t2080305/article/details/80560474" rel="external nofollow noreferrer">maven pom.xml 中 dependencyManagement和dependencies详解</a></p>
<p>现在的项目基本上都是使用多module来管理的，这就涉及到一个问题，多module之间如何使用共同的第三方jar,或者说如何减少相同的jar导入的配置。</p>
<p>1. 首先介绍&lt;dependencies&gt;</p>
<p>我们是这里引入了一个jar包之后，这里如果没有加上version版本号的话，那么maven就会去&lt;dependencyManagement&gt;里找对应groupId和artifactId的jar,如果有就继承他，如果没有就会报错，这时候其实在我们配置的本地仓库中会真实的下载对应的jar包，这时候所有的子module都会默认继承这里面所有声明的jar</p>
<p>2.&nbsp;&lt;dependencyManagement&gt;</p>
<p>这里其实是起到管理依赖jar版本号的作用，一般只会在项目的最顶层的pom.xml中使用到，所有子module如果想要使用到这里面声明的jar，只需要在子module中添加相应的groupId和artifactId即可，并不需要声明版本号，需要注意的是这里面只是声明一个依赖，并不是真实的下载jar，只有在子module中使用到，才会去下载依赖。</p>
<p><strong>2 dependencies 与dependencyManagement 的区别&nbsp;</strong></p>
<div>dependencies</div>
<div>相对于 dependencyManagement，所有声明在父项目中 dependencies 里的依赖都会被子项目自动引入，并默认被所有的子项目继承。</div>
<div>区别</div>
<div>dependencies 即使在子项目中不写该依赖项，那么子项目仍然会从父项目中继承该依赖项（全部继承）</div>
<div>dependencyManagement 里只是声明依赖，并不实现引入，因此子项目需要显示的声明需要用的依赖。如果不在子项目中声明依赖，是不会从父项目中继承下来的；只有在子项目中写了该依赖项，并且没有指定具体版本，才会从父项目中继承该项，并且 version 和 scope 都读取自父 pom; 另外如果子项目中指定了版本号，那么会使用子项目中指定的jar版本。</div>
<p>dependencies即使在子项目中不写该依赖项，那么子项目仍然会从父项目中继承该依赖项（全部继承）</p>
<p>dependencyManagement里只是声明依赖，并不实现引入，因此子项目需要显示的声明需要用的依赖。如果不在子项目中声明依赖，是不会从父项目中继承下来的；只有在子项目中写了该依赖项，并且没有指定具体版本，才会从父项目中继承该项，并且version和scope都读取自父pom;另外如果子项目中指定了版本号，那么会使用子项目中指定的jar版本。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2xjo97.html">LINQ to SQL Select查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pv3y9x.html">将一句话里的单词进行倒置，标点符号不倒换。比如将&OpenCurlyDoubleQuote;I come from Shanghai&period;&rdquo;倒换后变为&OpenCurlyDoubleQuote;Shanghai&period; from come I&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwolor9.html">5Hibernate配置及使用方法----青软S2SH&lpar;笔记&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96zjwnq.html">&lbrack;html&rsqb;三列居中自动伸缩的结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93k6ewq.html">HFSS使用记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/3900lj39.html">宫格布局实例（注意jquery的版本号要统一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9plmrdq.html">重新想象 Windows 8&period;1 Store Apps &lpar;77&rpar; - 控件增强&colon; 文本类控件的增强&comma; 部分控件增加了 Header 属性和 HeaderTemplate 属性&comma; 部分控件增加了 PlaceholderText 属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v4lpn8.html">停车场管理软件附带源代码 J2EE服务端&plus;android客户端</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yo1zn8.html">osgi实战学习之路&colon;8&period; Service-3之ServiceTracker</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzeege8.html">FZU 1502 Letter Deletion</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jezn38.html">requests&plus;正则表达式爬取ip</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyyz2v9.html">man rpcbind&lpar;rpcbind中文手册&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdlo3d9.html">POJ1108&lowbar;Split Windows 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j3p4nq.html">C&plus;&plus; 下面的AIDL</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw2lv48.html">Kubernetes-2--安装部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw5r6d8.html">CAS缺点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgnv6q.html">shiro 认证思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvye4gq.html">（原创）如何使用boost&period;asio写一个简单的通信程序（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koogv7q.html">文字超过字符长度 显示&amp;hellip&semi; 点点点 jquery</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmn1ve9.html">html select 和dropdownlist小结收集</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2emky9.html">前端使用 Nginx 反向代理彻底解决跨域问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rv7j58.html">&period;NET中使用Redis 转发</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4mvvx9.html">Python脱产8期 Day07 2019&sol;4&sol;19</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g32xeq.html">&lbrack;intoj&num;7&rsqb;最短距离</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvl3lz8.html">浅析mysql中exists 与 in 的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zykd4d9.html">OPPO Developers Conference（2018&period;12&period;26）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwj6p09.html">&period;NET-记一次架构优化实战与方案-梳理篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjm0p59.html">Pointcut 笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rd75m9.html">Nginx监控运维</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlloe00q.html">windows安装Redis和客户端</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
